extends Node

var ITEM_IDS_BY_CLASS := {
	# Not in pool
	KeyItem: 1,
	BombItem: 2,
	KeysItem: 3,
	BombsItem: 4,
	CoinsItem: 5,
	HeartItem: 6,
	ShieldItem: 7,
	HeartReceptacleItem: 8,
	# All items in pool
	DamagePotionItem: 9,
	FireRatePotionItem: 10,
	DoTPotionItem: 11,
	RangePotionItem: 12,
	LuckPotionItem: 13,
	CriticalDamagePotionItem: 14,
	CriticalChancePotionItem: 15,
	DashItem: 16,
	LightningItem: 17,
	LaserItem: 18,
	ExplosionItem: 19,
	TripleShotItem: 20,
	HomingItem: 21,
	QuadShotItem: 22,
	ShockwaveItem: 23,
	SteroidsItem: 24,
	RestartFloorItem: 25,
	StatDownDefenseItem: 26,
	BigFireRateItem: 27,
	SineItem: 28,
	AllStatsUpItem: 29,
	LotOfBombsItem: 30,
	LotOfKeysItem: 31,
	PoisonItem: 32,
	FireItem: 33,
	BigDoTItem: 34,
	DoTBookItem: 35,
	BleedingItem: 36,
	InvicibilityItem: 37,
	HealItem: 38,
	SingleUseHomingItem: 39,
	GiftItem: 40,
	NoShieldBonusItem: 41,
	NoHeartBonusItem: 42,
	EvadeFirstBlowItem: 43,
	BubbleItem: 44,
	HackerItem: 45,
	HeartReceptacleConverterItem: 46,
	ReviveItem: 47,
	DarkKeyItem: 48,
	RerollItem: 49,
	InfiniteBombsItem: 50,
	RerollDoorsItem: 51,
	SingleUseRerollItem: 52,
	SingleUseRerollDoorsItem: 53,
	RestartRoomItem: 54,
	GrenadeLauncherItem: 55,
	FireArrowItem: 56,
	OrbitalItem: 57,
	WaveItem: 58,
	FragmentationItem: 59,
	EnergyBallItem: 60,
	ShieldAssistItem: 61,
	ScytheAssistItem: 62,
	WispAssistItem: 63,
	DecoyAssistItem: 64,
	SkullflameAssistItem: 65,
	FrogAssistItem: 66,
	BoomerangItem: 67,
	LandmineItem: 68,
	BossKeyItem: 69,
	PoisonPuddleItem: 70,
	MoreCoinsItem: 71,
	SoulsConverterItem: 72,
	DoubleDashItem: 73,
	BiggerBombItem: 74,
	NoHeartItem: 75,
	PoisonPuddleOnImpactItem: 76,
	BrokenShieldItem: 77,
	AlterningItemsItem: 78,
	GlitchItem: 79,
	BigLuckItem: 80,
	SingleUseHealItem: 81,
	SpeedItem: 82,
	FireRateWhenIdleItem: 83,
	DamageAfterDashItem: 84,
	ShockwaveOnDashItem: 85,
	TheChallengeItem: 86,
	LittleWispAssistItem: 87,
	DiscountItem: 88,
	FakeHeartsItem: 89,
	BleedOnCritItem: 90,
	SuperRerollItem: 91,
	MixItem: 92,
	SummonerItem: 93,
	BatteryItem: 94,
	BigBatteryItem: 95,
	ExplodingSquirrelAssistItem: 96,
	FlailAssistItem: 97,
	RerollIntoDamageItem: 98,
	KnightItem: 99,
	}
var RARITY_BY_CLASS := {
	KeyItem: 0,
	BombItem: 0,
	KeysItem: 0,
	BombsItem: 0,
	CoinsItem: 0,
	HeartItem: 0,
	ShieldItem: 0,
	HeartReceptacleItem: 0,
	DamagePotionItem: 0,
	FireRatePotionItem: 0,
	DoTPotionItem: 10,
	RangePotionItem: 20,
	LuckPotionItem: 20,
	CriticalDamagePotionItem: 10,
	CriticalChancePotionItem: 10,
	DashItem: 10,
	LightningItem: 80,
	LaserItem: 40,
	ExplosionItem: 50,
	TripleShotItem: 70,
	HomingItem: 60,
	ShockwaveItem: 70,
	SteroidsItem: 50,
	RestartFloorItem: 70,
	StatDownDefenseItem: 60,
	BigFireRateItem: 20,
	SineItem: 0,
	LotOfBombsItem: 60,
	LotOfKeysItem: 60,
	PoisonItem: 20,
	FireItem: 20,
	BigDoTItem: 30,
	DoTBookItem: 40,
	BleedingItem: 20,
	InvicibilityItem: 70,
	SingleUseHomingItem: 30,
	NoShieldBonusItem: 40,
	NoHeartBonusItem: 20,
	BubbleItem: 70,
	RerollItem: 70,
	RerollDoorsItem: 70,
	SingleUseRerollItem: 10,
	SingleUseRerollDoorsItem: 10,
	RestartRoomItem: 20,
	GrenadeLauncherItem: 30,
	FireArrowItem: 30,
	OrbitalItem: 10,
	WaveItem: 80,
	FragmentationItem: 90,
	EnergyBallItem: 70,
	ShieldAssistItem: 60,
	ScytheAssistItem: 40,
	WispAssistItem: 50,
	DecoyAssistItem: 50,
	SkullflameAssistItem: 60,
	FrogAssistItem: 40,
	BoomerangItem: 50,
	LandmineItem: 20,
	PoisonPuddleItem: 30,
	MoreCoinsItem: 50,
	SoulsConverterItem: 20,
	DoubleDashItem: 0,
	PoisonPuddleOnImpactItem: 40,
	BrokenShieldItem: 40,
	AlterningItemsItem: 90,
	GlitchItem: 50,
	BigLuckItem: 50,
	SingleUseHealItem: 40,
	SpeedItem: 30,
	DamageAfterDashItem: 70,
	ShockwaveOnDashItem: 20,
	EvadeFirstBlowItem: 90,
	LittleWispAssistItem: 70,
	DiscountItem: 50,
	FakeHeartsItem: 70,
	BleedOnCritItem: 40,
	SuperRerollItem: 70,
	MixItem: 80,
	BatteryItem: 40,
	BigBatteryItem: 50,
	ExplodingSquirrelAssistItem: 60,
	FlailAssistItem: 50,
	}

var ITEMS_BY_ID := {}

var STATS_POOL := [
	DamagePotionItem,
	FireRatePotionItem,
	DoTPotionItem,
	RangePotionItem,
	LuckPotionItem,
	CriticalDamagePotionItem,
	CriticalChancePotionItem,
	]
var COMMON_POOL := STATS_POOL + [
	DashItem,
	BigFireRateItem,
	SineItem,
	LotOfBombsItem,
	LotOfKeysItem,
	BigDoTItem,
	DoTBookItem,
	SingleUseHomingItem,
	BubbleItem,
	SingleUseRerollItem,
	SingleUseRerollDoorsItem,
	OrbitalItem,
	ScytheAssistItem,
	WispAssistItem,
	FrogAssistItem,
	BoomerangItem,
	PoisonPuddleItem,
	SoulsConverterItem,
	PoisonPuddleOnImpactItem,
	BigLuckItem,
	SingleUseHealItem,
	SpeedItem,
	ShockwaveOnDashItem,
	EvadeFirstBlowItem,
	DiscountItem,
	BleedOnCritItem,
	MixItem,
	BatteryItem,
	]
var RARE_POOL := [
	DashItem,
	DamagePotionItem,
	FireRatePotionItem,
	SteroidsItem,
	PoisonItem,
	FireItem,
	BleedingItem,
	NoShieldBonusItem,
	NoHeartBonusItem,
	RerollDoorsItem,
	RestartRoomItem,
	FireArrowItem,
	WaveItem,
	EnergyBallItem,
	ShieldAssistItem,
	SkullflameAssistItem,
	LandmineItem,
	MoreCoinsItem,
	DoubleDashItem,
	InvicibilityItem,
	BrokenShieldItem,
	GlitchItem,
	DamageAfterDashItem,
	LaserItem,
	FakeHeartsItem,
	RerollItem,
	BigBatteryItem,
	FlailAssistItem,
	]
var LEGENDARY_POOL := [
	LightningItem,
	ExplosionItem,
	TripleShotItem,
	HomingItem,
	ShockwaveItem,
	StatDownDefenseItem,
	GrenadeLauncherItem,
	FragmentationItem,
	DecoyAssistItem,
	AlterningItemsItem,
	LittleWispAssistItem,
	RestartFloorItem,
	SuperRerollItem,
	ExplodingSquirrelAssistItem,
	]

var LOCKED_ITEMS := {
	FireRateWhenIdleItem: "CHALLENGE_1",
	NoHeartItem: "CHALLENGE_2",
	QuadShotItem: "CHALLENGE_3",
	BossKeyItem: "CHALLENGE_4",
	DarkKeyItem: "CHALLENGE_5",
	HackerItem: "CHALLENGE_6",
	HealItem: "CHALLENGE_7",
	GiftItem: "CHALLENGE_8",
	InfiniteBombsItem: "CHALLENGE_9",
	HeartReceptacleConverterItem: "CHALLENGE_10",
	ReviveItem: "CHALLENGE_11",
	BiggerBombItem: "CHALLENGE_12",
	TheChallengeItem: "CHALLENGE_13",
	AllStatsUpItem: "CHALLENGE_14",
	SummonerItem: "CHALLENGE_15",
	KnightItem: "CHALLENGE_16",
	}

func _init():
	for item_class in ITEM_IDS_BY_CLASS.keys():
		ITEMS_BY_ID[ITEM_IDS_BY_CLASS[item_class]] = item_class
