class_name PlayerState
extends Resource

@export var controller_number := 1
@export var color_number := 1
@export var hit_points := 4
@export var max_hit_points := 4
@export var nb_shields := 0
@export var nb_fake_hearts := 0

@export var activable_item_id := 0
@export var activable_item_charges := 0
@export var single_use_item_id := 0
@export var item_ids: Array[int] = []
@export var revive_used := false
@export var total_received_damages := 0

func is_alive():
	return hit_points > 0 or nb_shields > 0

func get_nb_hearts_and_shields() -> int:
	return ceili(max_hit_points / 2.0) + nb_fake_hearts + nb_shields

func fill_red_heart():
	if not is_alive() and max_hit_points < 2: # If we are dead, this allow to revive
		max_hit_points = 2
	
	hit_points += 2
	if hit_points > max_hit_points:
		hit_points = max_hit_points

func fill_all_red_hearts():
	if not is_alive() and max_hit_points < 2: # If we are dead, this allow to revive
		max_hit_points = 2
	
	hit_points = max_hit_points

func add_max_red_heart():
	if has_item(NoHeartItem):
		return
	
	if not has_item(TheChallengeItem):
		max_hit_points += 2
		if max_hit_points > 16:
			max_hit_points = 16
		
		_fix_heart_and_shield_number()
	
	fill_red_heart()

func add_shield():
	if has_item(BrokenShieldItem) or has_item(TheChallengeItem):
		return
	
	nb_shields += 1
	_fix_heart_and_shield_number()

func add_fake_heart():
	nb_fake_hearts += 1
	_fix_heart_and_shield_number()

func remove_heart_receptacle():
	if nb_fake_hearts > 0:
		nb_fake_hearts -= 1
	elif max_hit_points >= 2:
		max_hit_points -= 2
	
	if hit_points > max_hit_points:
		hit_points = max_hit_points

func has_item(item: GDScript) -> bool:
	return item_ids.find(Items.ITEM_IDS_BY_CLASS[item]) != -1

func _fix_heart_and_shield_number():
	while get_nb_hearts_and_shields() > 8:
			if nb_shields > 0:
				nb_shields -= 1
			elif nb_fake_hearts > 0:
				nb_fake_hearts -= 1
