extends CanvasLayer

var main_menu := preload("res://src/MainMenu.tscn")
var battlefield := preload("res://src/menus/pause_menu/PauseMenu.tscn")
var player_selection := preload("res://src/menus/player_selection/PlayerSelection.tscn")
var run_params := preload("res://src/menus/run_params/RunParams.tscn")
var settings := preload("res://src/menus/settings/Settings.tscn")
var credits := preload("res://src/menus/credits/Credits.tscn")

enum TransitionType {dissolve, slow_dissolve}

func change_scene(packed_scene: PackedScene, type: TransitionType = TransitionType.dissolve):
	if type == TransitionType.dissolve:
		_transition_dissolve(packed_scene)
	else:
		_transition_slow_dissolve(packed_scene)

func _transition_dissolve(packed_scene: PackedScene):
	$AnimationPlayer.play('dissolve')
	await $AnimationPlayer.animation_finished
	get_tree().change_scene_to_packed(packed_scene)
	get_tree().paused = false
	$AnimationPlayer.play_backwards('dissolve')

func _transition_slow_dissolve(packed_scene: PackedScene):
	$AnimationPlayer.play('slow_dissolve')
	await $AnimationPlayer.animation_finished
	get_tree().change_scene_to_packed(packed_scene)
	get_tree().paused = false
	$AnimationPlayer.play_backwards('slow_dissolve')
