extends AudioStreamPlayer

func _ready():
	process_mode = Node.PROCESS_MODE_ALWAYS

func play_basic_projectile(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.4 + randf()):
	_play_sound(_player, load("res://assets/sounds/shoot.wav"), -30.0 + _volume_db, _pitch_scale)

func play_arrow_projectile(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.4 + randf()):
	_play_sound(_player, load("res://assets/sounds/arrow.wav"), -24.0 + _volume_db, _pitch_scale)

func play_wave_projectile(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.4 + randf()):
	_play_sound(_player, load("res://assets/sounds/shoot.wav"), -30.0 + _volume_db, _pitch_scale)

func play_bubble(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.7 + randf() / 2):
	_play_sound(_player, load("res://assets/sounds/bubble.wav"), -5.0 + _volume_db, _pitch_scale)

func play_laser(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.7 + randf() / 2):
	_play_sound(_player, load("res://assets/sounds/electricity.wav"), -5.0 + _volume_db, _pitch_scale)

func play_electricity(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.7 + randf() / 2):
	_play_sound(_player, load("res://assets/sounds/electricity.wav"), -10.0 + _volume_db, _pitch_scale)

func play_explosion(_player: AudioStreamPlayer, _volume_db: float, _pitch_scale = 0.4 + randf()):
	_play_sound(_player, load("res://assets/sounds/explosion.wav"), -22.0 + _volume_db, _pitch_scale)

func play_door_open():
	_play_sound(self, load("res://assets/sounds/door_open.wav"), -20.0, 1.0)

func play_interaction():
	_play_sound(self, load("res://assets/sounds/interaction.wav"), -22.0, 1.0)

func play_error():
	_play_sound(self, load("res://assets/sounds/error.wav"), -22.0, 1.0)

func play_drop():
	_play_sound(self, load("res://assets/sounds/drop.wav"), -22.0, 1.0)

func _play_sound(_player: AudioStreamPlayer, _sound: Resource, _volume_db: float, _pitch_scale: float):
	if _player.stream != _sound:
		_player.stream = _sound
	_player.volume_db = _volume_db
	_player.pitch_scale = _pitch_scale
	_player.play()
