extends Node2D

@export_multiline var text: String : set = _set_text

var _nb_fade_in := 0

func _init():
	visible = false

func set_item(item_class: GDScript):
	$Label.text = "ITEM_%s" % Items.ITEM_IDS_BY_CLASS[item_class]
	
	var item := item_class.new() as BaseItem
	if item.is_activable:
		$TagBackground.visible = true
	
		if not item.single_use:
			$ActivableTag.visible = true
			$SingleUseTag.visible = false
		else:
			$ActivableTag.visible = false
			$SingleUseTag.visible = true
	else:
		$TagBackground.visible = false
		$ActivableTag.visible = false
		$SingleUseTag.visible = false

func _set_text(_text: String):
	$Label.text = _text

func fade_in(_controller_number: int):
	_nb_fade_in += 1
	$ActionButton.set_controller_number(_controller_number)
	
	if visible == false or modulate != Color.WHITE:
		modulate = Color.TRANSPARENT
		visible = true
		$Anim.play("fade_in")
		await $Anim.animation_finished
		visible = true # just in case fadeout was called just before

func fade_out(force := false):
	if force:
		_nb_fade_in = 0
	else:
		_nb_fade_in -= 1
	
	if modulate != Color.TRANSPARENT and _nb_fade_in == 0:
		$Anim.play("fade_out")
		await $Anim.animation_finished
		visible = false # needed for the action button to not be touchable while faded out

func show_button(_controller_number: int):
	$ActionButton.set_controller_number(_controller_number)
	$ActionButton.visible = true

func hide_button():
	$ActionButton.visible = false
