extends CanvasLayer

signal all_messages_read()

var _speaker_name := ""
var _texts: Array[String] = []
var _current_text_idx := 0

func _unhandled_input(_event: InputEvent) -> void:
	# Only the balloon is allowed to handle input while it's showing
	get_viewport().set_input_as_handled()
	
	if _event.is_action_pressed("p1_interaction") or _event.is_action_pressed("p2_interaction") or _event.is_action_pressed("p3_interaction") or _event.is_action_pressed("p4_interaction"):
		Sounds.play_interaction()
		
		if $DialogLabel.is_typing:
			$DialogLabel.skip_typing()
		else:
			_current_text_idx += 1
			if _current_text_idx >= _texts.size():
				all_messages_read.emit()
				queue_free()
			else:
				_display_current_text()

func start(texts: Array[String], speaker_name: String, controller_number: int):
	$ActionButton.set_controller_number(controller_number)
	
	_texts = texts
	_speaker_name = speaker_name
	_current_text_idx = 0
	
	_display_current_text()

func _display_current_text():
	$SpeakerLabel.text = _speaker_name
	$DialogLabel.text = tr(_texts[_current_text_idx])
	$DialogLabel.type_out()
