class_name Destroyable
extends StaticBody2D

var is_destroyed := false
var _ready_to_be_destroyed := false

signal destroyed(_player: Player)

func _ready():
	await get_tree().create_timer(2, false).timeout
	_ready_to_be_destroyed = true

func destroy(_player: Player, ignore_ready_delay := false):
	if (_ready_to_be_destroyed or ignore_ready_delay) and not is_destroyed:
		is_destroyed = true
		destroyed.emit(_player)
		
		EventBus.emit_create_effect(load("res://src/effects/particles/dust_puffs/BattleEndEffect.tscn").instantiate(), global_position)
		
		Sounds.play_explosion(Sounds, 0)
