class_name WithdrawalAltar
extends Interactable

signal withdrawal_done()
signal hack_failure(_player: Player)

var is_coin_altar := false

var _disabled := false

func _ready():
	$AnimationPlayer.play("appear")

func interact(_player: Player):
	if _disabled:
		return
	
	Sounds.play_interaction()
	
	if _player.state.has_item(HackerItem):
		if RoomUtils.try_hacking(_player):
			if is_coin_altar:
				Game.state.coins += 1
			else:
				_player.state.fill_red_heart()
			EventBus.update_battlefield_ui.emit()
		else:
			hack_failure.emit(_player)
	elif is_coin_altar and Game.state.coin_deposit > 0:
		Game.state.coins += 1
		Game.state.coin_deposit -= 1
		EventBus.update_battlefield_ui.emit()
		withdrawal_done.emit()
	elif not is_coin_altar and Game.state.heart_deposit > 0:
		_player.state.fill_red_heart()
		Game.state.heart_deposit -= 1
		EventBus.update_battlefield_ui.emit()
		withdrawal_done.emit()
	else:
		EventBus.emit_create_effect(TextEffect.new("NOTHING_IN_BANK"), _player.global_position)

func show_description(_controller_number: int):
	if not _disabled:
		$DescriptionLabel.fade_in(_controller_number)

func hide_description():
	$DescriptionLabel.fade_out()

func disable():
	_disabled = true
	$DescriptionLabel.fade_out()
