class_name CursedShopRoom
extends Node2D

var players: Array[Player]

var _cursed_item_reference := load("res://src/battlefield/rooms/cursed_shop_room/cursed_item/CursedItem.tscn") as PackedScene

func _ready():
	var nb_items := RoomUtils.get_nb_items(players)
	
	var items: Array[CursedItem] = []
	for i in nb_items:
		var cursed_item = _cursed_item_reference.instantiate() as CursedItem
		cursed_item.item_pool = Items.LEGENDARY_POOL
		items.append(cursed_item)
	
	var y_delta := 100.0
	
	for i in items.size():
		var x_delta := ((i - items.size() / 2.0) * 100) + 50
		
		var item = items[i]
		item.global_position = Vector2(x_delta, y_delta)
		add_child(item)
