extends Interactable

const _dialog_box_reference := preload("res://src/battlefield/dialogue/DialogueBox.tscn")

func _get_msg_base_key() -> String:
	return "TROPHY_FLOOR_%s_MSG" % Game.state.get_floor_number()

func interact(_player: Player):
	$DescriptionLabel.fade_out(true)
	
	# We automatically list the messages by checking string keys in the translations
	var msg_keys := RoomUtils.get_all_message_keys(_get_msg_base_key())
	
	if not msg_keys.is_empty():
		var dialog_box := _dialog_box_reference.instantiate()
		get_tree().current_scene.add_child(dialog_box)
		dialog_box.start(msg_keys, "CREATOR", _player.state.controller_number)
		dialog_box.all_messages_read.connect(_all_messages_read)

func _all_messages_read():
	EventBus.finish_run.emit()

func show_description(_controller_number: int):
	$DescriptionLabel.fade_in(_controller_number)

func hide_description():
	$DescriptionLabel.fade_out()
