extends Node2D

var players: Array[Player]

func _ready():
	if Game.state.room_type != Rooms.RoomType.item:
		$RerollMachine.free()
	
	var item_pool := []
	match Game.state.room_type:
		Rooms.RoomType.keys:
			item_pool = [KeysItem]
		Rooms.RoomType.bombs:
			item_pool = [BombsItem]
		Rooms.RoomType.coins:
			item_pool = [CoinsItem]
		Rooms.RoomType.heart:
			item_pool = [HeartItem]
		Rooms.RoomType.shield:
			item_pool = [ShieldItem]
		Rooms.RoomType.heart_receptacle:
			item_pool = [HeartReceptacleItem]
		Rooms.RoomType.item:
			item_pool = Items.COMMON_POOL
		Rooms.RoomType.boss:
			item_pool = Items.RARE_POOL
	
	var nb_items := RoomUtils.get_nb_items(players)
	
	if not item_pool.is_empty():
		var item_spacing := 260.0
		for i in nb_items:
			var x_delta := 0.0
			var y_delta := 0.0
			
			if nb_items >= 3:
				match i:
					0:
						x_delta = -item_spacing / 2
						y_delta = -item_spacing / 2
					1:
						x_delta = item_spacing / 2
						y_delta = -item_spacing / 2
					2:
						x_delta = -item_spacing / 2
						y_delta = item_spacing / 2
					3:
						x_delta = item_spacing / 2
						y_delta = item_spacing / 2
			elif nb_items == 2:
				match i:
					0:
						x_delta = -item_spacing / 2
					1:
						x_delta = item_spacing / 2
			
			var item_pedestal_reference := load("res://src/battlefield/rooms/generic_item_room/item_pedestal/ItemPedestal.tscn") as PackedScene
			var item_pedestal = item_pedestal_reference.instantiate()
			item_pedestal.item_pool = item_pool
			item_pedestal.global_position = Vector2(x_delta, y_delta)
			add_child(item_pedestal)
