class_name RerollMachine
extends Interactable

@export var price := 20

func _ready():
	$AnimationPlayer.play("appear")
	await $AnimationPlayer.animation_finished
	$AnimationPlayer.play("not_consumed")
	$PriceLabel.text = str(price)

func interact(_player: Player):
	if $MachineSprite2D/Destroyable.is_destroyed:
		return
	
	Sounds.play_interaction()
	
	if _player.state.has_item(HackerItem):
		if RoomUtils.try_hacking(_player):
			EventBus.reroll_all_items.emit(0, null)
		else:
			$MachineSprite2D/Destroyable.destroy(_player, true)
	elif Game.state.coins >= price:
		Game.state.coins -= price
		EventBus.reroll_all_items.emit(0, null)
		EventBus.emit_create_effect(TextEffect.new("-%s %s" % [price, tr("COINS")]), _player.global_position)
		EventBus.update_battlefield_ui.emit()
	else:
		EventBus.emit_create_effect(TextEffect.new("NOT_ENOUGH_COINS"), _player.global_position)

func show_description(_controller_number: int):
	if not $MachineSprite2D/Destroyable.is_destroyed:
		$DescriptionLabel.fade_in(_controller_number)

func hide_description():
	$DescriptionLabel.fade_out()

func _on_destroyable_destroyed(_player: Player):
	$MachineSprite2D.texture = load("res://src/battlefield/rooms/generic_item_room/reroll_machine/broken_reroll_machine.png")
	$MachineSprite2D/CoinSprite2D.visible = false
	$PriceLabel.visible = false
	EventBus.reroll_all_items.emit(0, null)
	$DescriptionLabel.fade_out(true)
	
	EventBus.on_machine_bombed.emit()
