class_name LaboratoryRoom
extends Node2D

var players: Array[Player]

var _lab_item_reference := load("res://src/battlefield/rooms/laboratory_room/laboratory_item/LaboratoryItem.tscn") as PackedScene

func _ready():
	var nb_items := RoomUtils.get_nb_items(players) + 1
	
	var items: Array[LaboratoryItem] = []
	for i in nb_items:
		var lab_item = _lab_item_reference.instantiate() as LaboratoryItem
		lab_item.item_pool = Items.STATS_POOL
		items.append(lab_item)
	
	var y_delta := 100.0
	
	for i in items.size():
		var x_delta := ((i - items.size() / 2.0) * 100) + 50
		
		var item = items[i]
		item.global_position = Vector2(x_delta, y_delta)
		add_child(item)
