class_name ShopRoom
extends Node2D

var players: Array[Player]

var _shop_item_reference := load("res://src/battlefield/rooms/shop_room/shop_item/ShopItem.tscn") as PackedScene

func _ready():
	var nb_items := RoomUtils.get_nb_items(players)
	
	var items: Array[ShopItem] = []
	for i in nb_items:
		var item = _shop_item_reference.instantiate() as ShopItem
		item.item_pool = Items.COMMON_POOL
		item.price = 30
		items.append(item)
	
	var key_item = _shop_item_reference.instantiate()
	key_item.item_pool = [KeyItem]
	key_item.price = 15
	key_item.infinite = true
	items.append(key_item)
	
	var bomb_item = _shop_item_reference.instantiate()
	bomb_item.item_pool = [BombItem]
	bomb_item.price = 15
	bomb_item.infinite = true
	items.append(bomb_item)
	
	var heart_item = _shop_item_reference.instantiate()
	heart_item.item_pool = [HeartItem]
	heart_item.price = 15
	heart_item.infinite = true
	items.append(heart_item)
	
	var shield_item = _shop_item_reference.instantiate()
	shield_item.item_pool = [ShieldItem]
	shield_item.price = 15
	shield_item.infinite = true
	items.append(shield_item)
	
	var y_delta := 100.0
	
	for i in items.size():
		var x_delta := ((i - items.size() / 2.0) * 100) + 50
		
		var item = items[i]
		item.global_position = Vector2(x_delta, y_delta)
		add_child(item)
