class_name Sign
extends Interactable

const _dialog_box_reference := preload("res://src/battlefield/dialogue/DialogueBox.tscn")

func _get_msg_base_key() -> String:
	return "SIGN_FLOOR_%s_MSG" % Game.state.get_floor_number()

func _ready():
	if Game.state.read_messages.find(_get_msg_base_key()) == -1:
		$CheckSprite2D.visible = false

func interact(_player: Player):
	Sounds.play_interaction()
	
	# We automatically list the messages by checking string keys in the translations
	var msg_keys := RoomUtils.get_all_message_keys(_get_msg_base_key())
	
	# This particular message is useless in touch mode
	if msg_keys.find("SIGN_FLOOR_1_MSG_4") != -1 and InputUtils.is_in_touch_mode():
		msg_keys.erase("SIGN_FLOOR_1_MSG_4")
	
	if not msg_keys.is_empty():
		var dialog_box := _dialog_box_reference.instantiate()
		get_tree().current_scene.add_child(dialog_box)
		dialog_box.start(msg_keys, "CREATOR", _player.state.controller_number)
		dialog_box.all_messages_read.connect(_all_messages_read)
	
	if Game.state.read_messages.find(_get_msg_base_key()) == -1:
		Game.state.read_messages.append(_get_msg_base_key())

func _all_messages_read():
	$CheckSprite2D.visible = true

func show_description(_controller_number: int):
	$DescriptionLabel.fade_in(_controller_number)

func hide_description():
	$DescriptionLabel.fade_out()
