class_name BaseFadeEffect
extends Node2D

var fade_in_duration := 0.2
var duration := 1.0
var fade_out_duration := 0.2

func _ready():
	modulate = Color.TRANSPARENT
	
	var tween := get_tree().create_tween().bind_node(self)
	tween.tween_property(self, "modulate", Color.WHITE, fade_in_duration)
	
	if process_mode == PROCESS_MODE_ALWAYS:
		await get_tree().create_timer(duration).timeout
	else:
		await get_tree().create_timer(duration, false).timeout
	
	tween = get_tree().create_tween().bind_node(self)
	await tween.tween_property(self, "modulate", Color.TRANSPARENT, fade_out_duration).finished
	queue_free()
