class_name CircleWarningEffect
extends BaseFadeEffect

var _enemy: Enemy
var _radius: float

func _init(enemy: Enemy, radius := 60.0):
	_enemy = enemy
	_radius = radius
	duration = 1.3

func _ready():
	super()
	EventBus.enemy_death.connect(_enemy_death)

func _enemy_death(_enemy_position: Vector2, _dead_enemy: Enemy):
	if _enemy == _dead_enemy:
		queue_free()

func _draw():
	var light_red := Color.RED
	light_red.a = 0.2
	var dark_red := Color.RED
	dark_red.a = 0.4
	
	draw_circle(Vector2.ZERO, _radius - 5, light_red)
	draw_arc(Vector2.ZERO, _radius, 0, TAU, int(_radius), dark_red, 4)
