class_name LineWarningEffect
extends BaseFadeEffect

var _enemy: Enemy
var _direction: Vector2
var _end_pos := Vector2.ZERO
var _width: float

func _init(enemy: Enemy, direction: Vector2, width := 50.0):
	_enemy = enemy
	_direction = direction
	_width = width

func _ready():
	super()
	EventBus.enemy_death.connect(_enemy_death)

func _enemy_death(_enemy_position: Vector2, _dead_enemy: Enemy):
	if _enemy == _dead_enemy:
		queue_free()

func _draw():
	if _end_pos == Vector2.ZERO:
		var ray = RayCast2D.new()
		ray.collision_mask = 1 # Walls
		
		add_child(ray)
		ray.target_position = _direction * 999
		ray.force_raycast_update()
		
		_end_pos = to_local(ray.get_collision_point())
		ray.queue_free()
	
	var light_red := Color.RED
	light_red.a = 0.2
	var dark_red := Color.RED
	dark_red.a = 0.4
	
	draw_line(Vector2.ZERO, _end_pos, light_red, _width)
