class_name PoisonPuddle
extends BaseFadeEffect

const _IMMUNIZATION_DURATION := 0.3
var emitting_player: Player
static var _immune_entities = []

func _init():
	duration = 3.0
	fade_out_duration = 1.5

func _ready():
	super()
	
	if not emitting_player:
		$Sprite2D.modulate = Color.from_string("#6cbf1e", Color.WHITE)
		$Area2D.call_deferred("set_collision_mask_value", 4, false)
		$Area2D.call_deferred("set_collision_mask_value", 2, true)
	
	rotation = randf_range(0, PI*2)

func _on_area_2d_body_entered(body: Node2D):
	if emitting_player and body is Enemy and _immune_entities.find(body) == -1:
		var dot_damage_factor :=  emitting_player.get_dot_damage_factor()
		var poison_damage = int(20.0 * dot_damage_factor)
		
		var enemy := body as Enemy
		_immune_entities.append(enemy)
		enemy.hurt(0, false, poison_damage, 0, 0)
		
		# get_parent().get_tree() to be sure the timer is not deleted after puddle is free
		await get_parent().get_tree().create_timer(_IMMUNIZATION_DURATION, false).timeout
		_immune_entities.erase(enemy)
	elif not emitting_player and body is Player and _immune_entities.find(body) == -1:
		var player := body as Player
		_immune_entities.append(player)
		player.hurt(1)
		
		# get_parent().get_tree() to be sure the timer is not deleted after puddle is free
		await get_parent().get_tree().create_timer(_IMMUNIZATION_DURATION, false).timeout
		_immune_entities.erase(player)
