class_name TextEffect
extends BaseFadeEffect

var text := ""
var color := Color.WHITE

func _init(_text: String, _duration := 0.8):
	text = _text
	duration = _duration
	z_index = 999 # Nothing can be above this

func _ready():
	var label := Label.new()
	label.text = text
	label.label_settings = LabelSettings.new()
	label.label_settings.outline_color = Color.BLACK
	label.label_settings.outline_size = 5
	label.label_settings.font_size = 24
	label.label_settings.font_color = color
	label.horizontal_alignment = HORIZONTAL_ALIGNMENT_CENTER
	label.autowrap_mode = TextServer.AUTOWRAP_WORD_SMART
	label.size = Vector2(300, 50)
	label.position = Vector2(-150, -20)
	add_child(label)
	
	var tween = get_tree().create_tween().bind_node(self)
	tween.set_ease(Tween.EASE_OUT)
	tween.set_trans(Tween.TRANS_QUAD)
	tween.tween_property(self, "position:y", position.y - 20, 0.3)
	
	super._ready()
