class_name BaseFollowAssist
extends CharacterBody2D

var _player: Player
var _enemy: Enemy

var _min_distance := 70
var _speed := Player.SPEED / 1.3

func set_player(player: Player):
	_player = player

func set_enemy(enemy: Enemy):
	_enemy = enemy

func _ready():
	if global_position == Vector2.ZERO:
		var random_direction := Vector2.from_angle(randf_range(0, PI*2))
		global_position = _get_creator_position() + (random_direction * 30)

func _process(_delta: float):
	var creator_position := _get_creator_position()
	var distance := creator_position.distance_to(global_position)
	
	if distance > _min_distance:
		var direction := global_position.direction_to(creator_position)
		
		set_velocity(direction * _speed)
		move_and_slide()
	
	_update_sprite_flip()

func _update_sprite_flip():
	if velocity != Vector2.ZERO:
		if velocity.x < 0:
			$Sprite2D.flip_h = true
		elif velocity.x > 0:
			$Sprite2D.flip_h = false

func _get_creator_position() -> Vector2:
	if _enemy:
		return _enemy.global_position
	elif _player:
		return _player.global_position
	else:
		return Vector2.ZERO

func _get_nearest_enemy() -> Node2D:
	return _player.get_nearest_enemy()
