class_name ExplodingSquirrelAssist
extends BaseRandomDirectionAssist

@onready var _weapon := $ModularWeapon as ModularWeapon

func _init():
	_speed = 80

func _ready():
	super()
	
	if _enemy:
		$Sprite2D.modulate = Color.from_string("#ff9453", Color.WHITE)
		call_deferred("set_collision_layer_value", 4, true) # We can be shooted by players
		$SurroundingDetectionArea2D.call_deferred("set_collision_mask_value", 4, false)
		$SurroundingDetectionArea2D.call_deferred("set_collision_mask_value", 2, true)

func set_player(player: Player):
	super(player)
	
	$ModularWeapon.player = player

func _on_modular_weapon_damaged(_target: Node2D, _damage: int):
	if _player and _target is Enemy:
		var real_damage := int(_damage * _player.get_damage_factor() * randf_range(0.9, 1.1))
		(_target as Enemy).hurt(real_damage, false, false, false, false)
	elif not _player and _target is Player:
		(_target as Player).hurt(1)

func _on_surrounding_detection_area_2d_body_entered(body: Node2D):
	if body is Enemy or body is Player:
		_speed = 300
		_aleatory_position = body.global_position
		$SurroundingDetectionArea2D.call_deferred("set_monitoring", false)
		
		await get_tree().create_timer(0.3, false).timeout
		
		explode()

func explode():
	$SurroundingDetectionArea2D.call_deferred("set_monitoring", false)
	_weapon.shoot(0, Vector2.ZERO)
	
	var tween = get_tree().create_tween().bind_node(self)
	tween.tween_property(self, "scale", Vector2.ZERO, 0.1)
	tween.tween_callback(self.queue_free)
