extends BaseRandomDirectionAssist

const _FIRE_DURATION := 2.0

@onready var _weapon := $ModularWeapon as ModularWeapon

var _firing_direction := Vector2.ZERO

func set_player(player: Player):
	super(player)
	
	$ModularWeapon.player = player

func _ready():
	super()
	
	if _player:
		$Timer.start(_get_random_delay())
	else:
		$AnimationPlayer.play("appear")
		$Timer.start(0.2)
		if specific_firing_direction == Vector2.ZERO:
			specific_firing_direction = _get_direction_to_aleatory_position()

func _process(delta: float):
	if _firing_direction == Vector2.ZERO:
		super(delta)
	else:
		_weapon.shoot(delta, _firing_direction)

func _on_timer_timeout():
	if _firing_direction == Vector2.ZERO:
		if specific_firing_direction == Vector2.ZERO:
				var nearest_enemy := _get_nearest_enemy()
				if nearest_enemy:
					$Timer.start(_FIRE_DURATION)
					_firing_direction = global_position.direction_to(nearest_enemy.global_position)
		else:
			$Timer.start(_FIRE_DURATION)
			_firing_direction = specific_firing_direction
	else:
		_weapon.stop_shooting()
		_firing_direction = Vector2.ZERO
		if _player:
			$Timer.start(_get_random_delay())
		else:
			$AnimationPlayer.play("disappear")
			await $AnimationPlayer.animation_finished
			queue_free()

func _on_modular_weapon_damaged(_target: Node2D, _damage: int):
	if _player and _target is Enemy:
		var real_damage := int(80.0 * _player.get_damage_factor() * randf_range(0.9, 1.1))
		(_target as Enemy).hurt(real_damage, false, false, false, false)
	elif not _player and _target is Player:
		(_target as Player).hurt(1)

func _get_random_delay() -> float:
	return randf_range(4.0, 8.0)
