extends Enemy

func _init():
	_nb_phases = 2
	
	_patterns.append(EnemyPattern.new(1.5, 2.5, _get_direction_to_nearest_player, __, _teleport_to_nearest_player))
	_patterns.append(_move_pattern(1.2, 1.2))
	_patterns.append(EnemyPattern.new(1.0, 2.0, _get_direction_to_nearest_player, _shoot_nearest_player, _shoot_grenades))

func _shoot_grenades():
	($GrenadeWeapon as ModularWeapon).shoot(0, Vector2.ZERO)

func _fire_shockwave():
	($ShockwaveWeapon as ModularWeapon).shoot(0, Vector2.ZERO)

func _on_new_phase(_phase_number: int):
	speed = 100
	
	($ModularWeapon as ModularWeapon).add_motion("res://src/weapon/ProjectileMotions/Motions/CurveMotion.tres")
	
	_patterns.clear()
	_patterns.append(EnemyPattern.new(1.0, 2.0, _get_direction_to_nearest_player, __, _teleport_to_nearest_player))
	_patterns.append(_move_pattern(1.2, 1.2))
	_patterns.append(EnemyPattern.new(0.5, 1.0, _get_direction_to_nearest_player, _shoot_nearest_player, _shoot_grenades))
	_patterns.append(EnemyPattern.new(2.0, 3.0, _get_direction_to_nearest_player, __, _fire_shockwave))
	_restart_patterns()
