extends Enemy

func _init():
	_nb_phases = 2
	
	_patterns.append(EnemyPattern.new(2.0, 2.0, _get_direction_opposite_to_nearest_player, __, _shoot_nearest_player))
	for i in 4:
		_patterns.append(EnemyPattern.new(0.3, 0.3, _get_direction_to_nearest_player, _charge, _drop_bomb))
	_patterns.append(EnemyPattern.new(1.5, 1.5, _get_direction_to_nearest_player, _charge, _stop_charge))

func _drop_bomb():
	($BombWeapon as ModularWeapon).shoot(0, Vector2.ZERO)

func _fire_circle_wave():
	($CircleWaveWeapon as ModularWeapon).shoot(0, Vector2.UP)
	await get_tree().create_timer(0.2, false).timeout
	($CircleWaveWeapon as ModularWeapon).shoot(0, Vector2.UP.rotated(PI/4))
	await get_tree().create_timer(0.2, false).timeout
	($CircleWaveWeapon as ModularWeapon).shoot(0, Vector2.UP.rotated(PI/2))
	await get_tree().create_timer(0.2, false).timeout
	($CircleWaveWeapon as ModularWeapon).shoot(0, Vector2.LEFT.rotated(PI/4))

func _on_new_phase(_phase_number: int):
	speed = 250
	charge_speed = 450
	
	_patterns.clear()
	_patterns.append(EnemyPattern.new(2.0, 2.0, _get_direction_opposite_to_nearest_player, __, _shoot_nearest_player))
	for i in 4:
		_patterns.append(EnemyPattern.new(0.3, 0.3, _get_direction_to_nearest_player, _charge, _drop_bomb))
	_patterns.append(EnemyPattern.new(1.0, 1.0, _get_direction_to_nearest_player, _charge, _stop_charge))
	_patterns.append(_wait_pattern(1.4, _teleport_to_center, _fire_circle_wave))
	_patterns.append(_wait_pattern(1.8))
	_restart_patterns()
