extends Enemy

func _init():
	_nb_phases = 2
	
	_patterns.append(_move_pattern(1.3, 1.5))
	for i in 4:
		_patterns.append(EnemyPattern.new(0.3, 0.5, _get_direction_to_nearest_player, _fire_grenade, __))
	_patterns.append(EnemyPattern.new(2.0, 2.0, _dont_move, _teleport_to_left, _fire_holed_shockwave))
	_patterns.append(_wait_pattern(5.0))
	_patterns.append(EnemyPattern.new(2.0, 2.0, _dont_move, _teleport_to_right, _fire_holed_shockwave))
	_patterns.append(_wait_pattern(5.0))

func _ready():
	super()
	
	var wave_emitter := _weapon.get_child(0) as WaveEmitter
	wave_emitter.fire_holed_circle = true

func _fire_holed_shockwave():
	if _current_phase == 1:
		_fire_angle(12, true, _weapon, _get_direction_to_nearest_player(), 0.3)
	else:
		_fire_angle(10, false, _weapon, _get_direction_to_nearest_player(), 0.3)

func _fire_grenade():
	_shoot_nearest_player($GrenadeWeapon)

func _on_new_phase(_phase_number: int):
	speed = 200
