extends Enemy

func _init():
	_nb_phases = 3
	
	_patterns.append(EnemyPattern.new(2.0, 2.0, _get_direction_opposite_to_nearest_player, __, _teleport_to_left))
	_patterns.append(EnemyPattern.new(1.3, 1.3, _get_direction_to_nearest_player, __, _fire_cone))
	_patterns.append(EnemyPattern.new(2.0, 2.0, _get_direction_to_nearest_player, __, _teleport_to_right))
	_patterns.append(EnemyPattern.new(1.3, 1.3, _get_direction_to_nearest_player, __, _fire_cone))
	_patterns.append(EnemyPattern.new(2.0, 2.0, _get_direction_to_nearest_player, __, _teleport_to_center))
	_patterns.append(EnemyPattern.new(1.2, 1.2, _get_direction_to_nearest_player, _fire_grenades, __))
	_patterns.append(EnemyPattern.new(6.0, 6.0, _dont_move, _long_fire_laser, __))

func _fire_cone():
	if _current_phase == 1:
		_fire_angle(10, true, _weapon, _get_direction_to_nearest_player())
	else:
		_fire_angle(20, true, _weapon, _get_direction_to_nearest_player())

func _fire_grenades():
	($GrenadeWeapon as ModularWeapon).shoot(0, Vector2.ZERO)
	
	if _current_phase == 3:
		await get_tree().create_timer(5, false).timeout
		($GrenadeWeapon as ModularWeapon).shoot(0, Vector2.ZERO)

func _long_fire_laser():
	if _current_phase == 1:
		_long_fire($LaserWeapon, 5.0)
	elif _current_phase == 2:
		_long_fire($LaserWeapon, 5.0, true)
	else:
		_long_fire($LaserWeapon, 3.5, true)

func _on_new_phase(_phase_number: int):
	speed = 150
	
	if _phase_number == 3:
		add_shield_assists()
