class_name BaseMenuScreen
extends Node2D

var _accepted_controller_number := [1, 2, 3, 4]

var _is_menu_up_pressed := false
var _is_menu_up_released := true

var _is_menu_down_pressed := false
var _is_menu_down_released := true

var _is_menu_left_pressed := false
var _is_menu_left_released := true

var _is_menu_right_pressed := false
var _is_menu_right_released := true

var _is_interaction_pressed := false
var _is_cancel_pressed := false

func _unhandled_input(_event: InputEvent):
	_is_menu_up_pressed = false
	_is_menu_down_pressed = false
	_is_menu_left_pressed = false
	_is_menu_right_pressed = false
	_is_interaction_pressed = false
	_is_cancel_pressed = false
	
	for controller_number in _accepted_controller_number:
		if _event.is_action_pressed("p%s_menu_up" % controller_number):
			if _is_menu_up_released:
				_is_menu_up_released = false
				_is_menu_up_pressed = true
			else:
				_is_menu_up_pressed = false
		elif _event.is_action_released("p%s_menu_up" % controller_number):
			_is_menu_up_released = true
			_is_menu_up_pressed = false
		
		if _event.is_action_pressed("p%s_menu_down" % controller_number):
			if _is_menu_down_released:
				_is_menu_down_released = false
				_is_menu_down_pressed = true
			else:
				_is_menu_down_pressed = false
		elif _event.is_action_released("p%s_menu_down" % controller_number):
			_is_menu_down_released = true
			_is_menu_down_pressed = false
		
		if _event.is_action_pressed("p%s_menu_left" % controller_number):
			if _is_menu_left_released:
				_is_menu_left_released = false
				_is_menu_left_pressed = true
			else:
				_is_menu_left_pressed = false
		elif _event.is_action_released("p%s_menu_left" % controller_number):
			_is_menu_left_released = true
			_is_menu_left_pressed = false
		
		if _event.is_action_pressed("p%s_menu_right" % controller_number):
			if _is_menu_right_released:
				_is_menu_right_released = false
				_is_menu_right_pressed = true
			else:
				_is_menu_right_pressed = false
		elif _event.is_action_released("p%s_menu_right" % controller_number):
			_is_menu_right_released = true
			_is_menu_right_pressed = false
		
		if _event.is_action_pressed("p%s_interaction" % controller_number):
			_is_interaction_pressed = true
		
		if _event.is_action_pressed("p%s_cancel" % controller_number):
			_is_cancel_pressed = true
