extends Node2D

signal on_pressed()
@export var text := ""
@export var is_ok_button := true

func _ready():
	var joypad_type := InputUtils.get_type_for(1)
	
	if is_ok_button:
		if text != "":
			$Label.text = text
		else:
			$Label.text = "OK"
		
		$Sprite2D.hframes = 4
		match joypad_type:
			InputUtils.JoypadType.TOUCH:
				$Sprite2D.texture = null
			InputUtils.JoypadType.KEYBOARD:
				$Sprite2D.texture = load("res://src/menus/buttons/keyboard_action_button.png")
			InputUtils.JoypadType.PLAYSTATION:
				$Sprite2D.texture = load("res://src/menus/buttons/playstation_action_button.png")
			InputUtils.JoypadType.NINTENDO:
				$Sprite2D.texture = load("res://src/menus/buttons/nintendo_action_button.png")
			_:
				$Sprite2D.texture = load("res://src/menus/buttons/xbox_action_button.png")
	else:
		if text != "":
			$Label.text = text
		else:
			$Label.text = "BACK"
		
		match joypad_type:
			InputUtils.JoypadType.TOUCH:
				$Sprite2D.texture = null
			InputUtils.JoypadType.KEYBOARD:
				$Sprite2D.texture = load("res://src/menus/controller_indication/esc.png")
			InputUtils.JoypadType.PLAYSTATION:
				$Sprite2D.texture = load("res://src/menus/buttons/playstation_back_button.png")
			InputUtils.JoypadType.NINTENDO:
				$Sprite2D.texture = load("res://src/menus/buttons/nintendo_back_button.png")
			_:
				$Sprite2D.texture = load("res://src/menus/buttons/xbox_back_button.png")

func _on_label_pressed():
	on_pressed.emit()
