class_name DrawUtils

static func draw_circle(line: Line2D, radius: float, color: Color, width: float):
	draw_arc(line, radius, color, width, 0, TAU)

static func draw_arc(line: Line2D, radius: float, color: Color, width: float, start_angle: float, end_angle: float):
	line.default_color = color
	line.width = width
	
	line.clear_points()
	var nb_points := int(radius / (TAU / (end_angle - start_angle)))
	for i in nb_points:
		var point := Vector2(radius - (width / 2.0), 0).rotated(start_angle).rotated(i * (end_angle - start_angle) / (nb_points - 1))
		line.add_point(point)

#static func draw_filled_circle(polygon: Polygon2D, radius: float, color: Color):
#	polygon.color = color
#
#	var points := PackedVector2Array()
#	var nb_points := int(radius)
#	for i in nb_points:
#		var point := Vector2(radius, 0).rotated(i * TAU / (nb_points - 1))
#		points.append(point)
#
#	polygon.polygon = points
