class_name BombEffect
extends CharacterBody2D

signal exploded(pos: Vector2)

var _motion := Vector2.ZERO
var _first_body := true

func _ready():
	$Anim.play("Effect")

func _on_anim_animation_finished(_anim_name: String):
	exploded.emit(global_position)
	queue_free()

func _physics_process(_delta):
	velocity = velocity.normalized() * _motion.length()
	var collision := move_and_collide(velocity * _delta)
	if collision:
		velocity = velocity.bounce(collision.get_normal())

func _on_area_2d_body_entered(_body: Node2D):
	if _body is Player && not _first_body:
		var player := _body as Player
		var player_motion := player.get_last_motion() as Vector2
		if player_motion != Vector2.ZERO:
			_motion = player_motion.normalized() * 320
			velocity = _motion
			
			var tween := get_tree().create_tween().bind_node(self)
			tween.set_ease(Tween.EASE_OUT)
			tween.set_trans(Tween.TRANS_QUAD)
			tween.tween_property(self, "_motion", Vector2.ZERO, 2)

func _on_area_2d_body_exited(_body: Node2D):
	_first_body = false
