extends ProjectileEmitter

var _projectile := preload("EnergyBallProjectile.tscn")

@onready var timer := $Timer

# Spawns and configures a basic projectile scene and connects to its signals.
func _do_fire(_delta: float, _direction: Vector2) -> bool:
	if not timer.is_stopped():
		return false
	
	var new_projectile := _projectile.instantiate() as Projectile
	new_projectile.setup(weapon, global_position, _direction.rotated(global_rotation), _get_real_max_distance())
	EventBus.create_projectile.emit(new_projectile)
	
	new_projectile.collided.connect(_on_projectile_collided)
	new_projectile.missed.connect(_on_projectile_missed)
	
	timer.start(1.0 / _get_real_projectiles_per_second())
	
	return true
