class_name EnergyBallProjectile
extends Projectile

var max_radius := 25.0
var _radius := 0.0

var _color := Color.STEEL_BLUE
var _dark_color := Color.DARK_BLUE
var _fill_color := Color.WHITE

func _init():
	super()
	_fill_color.a = 0.9

func _ready():
	Sounds.play_basic_projectile($ShootSound, weapon.get_volume_db_adjustment())
	
	rotation = direction.angle()
	$CollisionShape2D.shape.radius = 0.0
	
	if not weapon.player:
		z_index = 10
		_color = Color.RED
		_dark_color = Color.DARK_RED
	
	$Trail.modulate = _color

func _process(_delta: float):
	if _radius != max_radius:
		_radius = 80.0 * elapsed_time
		if _radius > max_radius:
			_radius = max_radius
		
		$CollisionShape2D.shape.radius = _radius
		_draw_ball()
		queue_redraw()

func _draw_ball():
	if _radius > 5:
		DrawUtils.draw_circle($FirstLine2D, _radius + 2.0, _color, 4.0)
		DrawUtils.draw_circle($SecondLine2D, _radius - 2.0, _dark_color, 4.0)
		#TODO can do that until https://github.com/godotengine/godot/issues/80687 is fixed
		#DrawUtils.draw_filled_circle($Polygon2D, _radius - 4.0, _fill_color)

func _draw():
	if _radius > 5:
		draw_circle(Vector2.ZERO, _radius - 4.0, _fill_color)
