extends GrenadeProjectile

func _init():
	automatically_apply_rotation = false

func _ready():
	super()
	
	if not weapon.player:
		EventBus.detonate_landmines.connect(_detonate_landmine)
		
		$Sprite2D.modulate = Color.from_string("#ff9453", Color.WHITE)

func _on_final_position_reached():
	$Area2D.call_deferred("set_monitoring", true)

func _on_area_2d_body_entered(body: Node2D):
	if (weapon.player and body is Enemy) or (not weapon.player and body is Player):
		_explode()

func _detonate_landmine():
	await get_tree().create_timer(randf_range(0.3, 1.3), false).timeout # avoid having all the explosing sounds in the same time
	
	_explode()

func _explode():
	# not collided to avoid doing damage directly (only the explosion will do some)
	missed.emit(global_position)
	_destroy()
