extends ProjectileEmitter

@onready var timer := $Timer as Timer

@export_range(1, 10) var flashes := 2
@export_range(0.0, 3.0) var flash_time := 0.1
@export var lightning_jolt := preload("res://src/weapon/ProjectileEmitters/Lightning/LightningJolt.tscn")

func _ready():
	damage_per_collision = 70

func _do_fire(_delta: float, _direction: Vector2) -> bool:
	if not timer.is_stopped():
		return false
	
	timer.start(1.0 / _get_real_projectiles_per_second())
	
	var real_max_distance := _get_real_max_distance()
	for flash in range(flashes):
		var jolt = lightning_jolt.instantiate() as LightningJolt
		jolt.collided.connect(_on_projectile_collided)
		jolt.missed.connect(_on_projectile_missed)
		add_child(jolt)
		jolt.create(weapon, global_position, to_global(_direction * real_max_distance))
		
		await get_tree().create_timer(flash_time, false).timeout
	
	return true
