extends ProjectileEmitter

var _projectile := preload("res://src/weapon/ProjectileEmitters/Grenade/GrenadeProjectile.tscn")

# Spawns and configures a basic projectile scene and connects to its signals.
func _do_fire(_delta: float, _direction: Vector2) -> bool:
	if not weapon.player:
		EventBus.emit_create_effect(CircleWarningEffect.new(weapon.get_enemy_owner(), weapon.warning_radius), _direction, false)
		await get_tree().create_timer(0.3, false).timeout
	
	var new_projectile := _projectile.instantiate() as GrenadeProjectile
	new_projectile.use_direction_as_destination = true
	new_projectile.setup(weapon, global_position, _direction, _get_real_max_distance())
	EventBus.create_projectile.emit(new_projectile)
	
	new_projectile.collided.connect(_on_projectile_collided)
	new_projectile.missed.connect(_on_projectile_missed)
	
	return true
