class_name Explosion
extends Sprite2D

var weapon: ModularWeapon
var explosion_damage: int
var entity_to_ignore: Node2D

func _ready():
	if not weapon.player:
		$Area2D.call_deferred("set_collision_mask_value", 4, false)
		$Area2D.call_deferred("set_collision_mask_value", 2, true)
	
	if weapon.can_destroy_objects:
		$Area2D.call_deferred("set_collision_mask_value", 6, true)
		
	Sounds.play_explosion($Sound, weapon.get_volume_db_adjustment())
	
	match randi_range(0, 3):
		1:
			rotation_degrees = 90
		2:
			rotation_degrees = 180
		3:
			rotation_degrees = 270

func _on_area_2d_body_entered(body: Node2D):
	if body != entity_to_ignore and is_instance_valid(weapon):
		weapon.damaged.emit(body, explosion_damage)

func _on_animation_finished(_anim_name: String):
	queue_free()
