extends ProjectileImpact

@export var explosion_damage := 150

var explosion_effect := preload("Explosion.tscn")


# Spawns a new explosion, positions it and triggers its animation.
# Causes damage based on proximity to the explosion.
func _do_trigger(_spawn_location: Vector2, _weapon: ModularWeapon, _missed: bool, _entity_to_ignore: Node2D):
	var explosion := explosion_effect.instantiate() as Explosion
	explosion.weapon = _weapon
	explosion.entity_to_ignore = _entity_to_ignore
	explosion.explosion_damage = explosion_damage
	
	EventBus.emit_create_effect(explosion, _spawn_location)
