class_name Fragmentation
extends Node2D

var original_weapon: ModularWeapon

func get_fragmentation_weapon() -> ModularWeapon:
	return $FragmentationWeapon as ModularWeapon

func _ready():
	get_fragmentation_weapon().shoot(0, Vector2.UP)
	Sounds.play_basic_projectile($Sound, original_weapon.get_volume_db_adjustment())
	
	# With LandmineEmitter, we cannot kill it after 6s because landmine may have not exploded yet
	# This is clearly a leak that should be fixed
	var emitter_script := original_weapon.get_child(0).get_script() as GDScript
	if emitter_script != LandmineEmitter:
		await get_tree().create_timer(6, false).timeout
		queue_free()

func _on_fragmentation_weapon_damaged(target: Node2D, amount: int):
	original_weapon.damaged.emit(target, max(1, int(amount / 3.0)))
