class_name FragmentationImpact
extends ProjectileImpact

var fragmentation_effect := preload("Fragmentation.tscn")


# Spawns a new explosion, positions it and triggers its animation.
# Causes damage based on proximity to the explosion.
func _do_trigger(_spawn_location: Vector2, _weapon: ModularWeapon, _missed: bool, _entity_to_ignore: Node2D):
	var fragmentation := fragmentation_effect.instantiate() as Fragmentation
	fragmentation.original_weapon = _weapon
	
	var fragmentation_weapon := fragmentation.get_fragmentation_weapon()
	fragmentation_weapon.player = _weapon.player
	fragmentation_weapon.additionnal_volume_db_adjustment = _weapon.get_volume_db_adjustment()
	fragmentation_weapon.projectile_emitter = _weapon.projectile_emitter
	fragmentation_weapon.projectile_motions = _weapon.projectile_motions
	for impact in _weapon.projectile_impacts:
		if impact.get_script() != FragmentationImpact: # to avoid infinite recursion
			fragmentation_weapon.projectile_impacts.append(impact)
	
	EventBus.emit_create_effect(fragmentation, _spawn_location)
