extends ProjectileImpact

@export var lightning_damage := 50
var lightning_zone_effect := preload("LightningZone.tscn")


# Spawns a new explosion, positions it and triggers its animation.
# Causes damage based on proximity to the explosion.
func _do_trigger(_spawn_location: Vector2, _weapon: ModularWeapon, _missed: bool, _entity_to_ignore: Node2D):
	var lightning_zone := lightning_zone_effect.instantiate() as LightningZone
	lightning_zone.weapon = _weapon
	lightning_zone.entity_to_ignore = _entity_to_ignore
	lightning_zone.lightning_damage = lightning_damage
	
	EventBus.emit_create_effect(lightning_zone, _spawn_location)
