class_name LightningZone
extends Area2D

var weapon: ModularWeapon
var lightning_damage: int
var entity_to_ignore: Node2D

@export var lightning_jolt := preload("res://src/weapon/ProjectileEmitters/Lightning/LightningJolt.tscn")

func _on_body_entered(body: Node2D):
	if body is Enemy and body != entity_to_ignore:
		var jolt = lightning_jolt.instantiate() as LightningJolt
		jolt.collided.connect(_on_jolt_collided)
		add_child(jolt)
		jolt.create(weapon, global_position, body.global_position)

func _on_jolt_collided(target: Node, _hit_location: Vector2):
	if target is Enemy:
		weapon.damaged.emit(target, lightning_damage)

func _on_timer_timeout():
	queue_free()
