extends ProjectileImpact

var _energy_ball_projectile_scene := preload("res://src/weapon/ProjectileEmitters/EnergyBall/EnergyBallProjectile.tscn")

func _do_trigger(_spawn_location: Vector2, _weapon: ModularWeapon, _missed: bool, _entity_to_ignore: Node2D):
	for i in 8:
		var new_projectile := _energy_ball_projectile_scene.instantiate() as EnergyBallProjectile
		new_projectile.max_radius = 10
		var direction := Vector2.UP.rotated(i * (PI / 4))
		var sub_projectile_max_distance :=  (_weapon.max_distance * _weapon.get_range_factor()) / 4
		new_projectile.setup(_weapon, _spawn_location + direction * 15, direction, sub_projectile_max_distance)
		EventBus.create_projectile.emit(new_projectile)
		
		new_projectile.collided.connect(func(target: Node2D, _hit_location: Vector2): _weapon.damaged.emit(target, 20))
