class_name BoomerangMotion
extends ProjectileMotion

const _MAX_SPEED_ON_RETURN := 0.7

func update_movement(_projectile: Projectile, _movement_vector: Vector2, _direction: Vector2, _delta: float) -> Vector2:
	var speed_factor := 1 - _projectile.get_distance_progression()
	if speed_factor < 0.05 and _projectile.boomerang_phase == 0:
		_projectile.boomerang_phase = 1
		_projectile.direction = _projectile.direction.rotated(PI)
	elif speed_factor > _MAX_SPEED_ON_RETURN and _projectile.boomerang_phase == 1:
		_projectile.boomerang_phase = 2
	
	if _projectile.boomerang_phase == 2:
		speed_factor = _MAX_SPEED_ON_RETURN
	
	return _movement_vector * speed_factor
