class_name SineMotion
extends ProjectileMotion

# Amplitude of the sine wave in pixels relative to the emission point.
@export var amplitude := 100.0
# Number of waves the sine draws per second.
@export var frequency := 3.0

# Moves the projectile perpendicular to its travel direction in a sine wave
# pattern.
func update_movement(_projectile: Projectile, _movement_vector: Vector2, _direction: Vector2, _delta: float) -> Vector2:
	var moving_amplitude := amplitude * sin(Time.get_unix_time_from_system() * 3)
	var wobble_amount := moving_amplitude * sin(_projectile.elapsed_time * frequency * PI + (frequency / 2.0)) * frequency
	
	var travel_direction := Vector2(-_direction.y, _direction.x)
	return _movement_vector + travel_direction * wobble_amount * _delta
